#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdbool.h>
#include <poll.h>
#include <string.h>
#include <time.h>
#include <signal.h>
#include <fcntl.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <netinet/tcp.h>

//#include "common.h"

#define Key_DevName     "/dev/hidg0"

static unsigned char gKeyNumValue[10] = 
{
    0x62, /*0*/
    0x59, /*1*/
    0x5A, /*2*/
    0x5B, /*3*/
    0x5C, /*4*/
    0x5D, /*5*/
    0x5E, /*6*/
    0x5F, /*7*/
    0x60, /*8*/
    0x61, /*9*/
};

static int key_fd = -1;

#ifdef DEBUG
static int idx = 0;
#endif

#define DELAY_TIME()	//usleep(50000)
#define DELAY_WAIT_TIME()  usleep(100*1000)
static bool Hid_Send_OneGBKEnglish(const unsigned char charactor)
{
    int offset = 0;
	static unsigned char charBase = 0x04; /* A or a */
    unsigned char keyType = 0;
    unsigned char report[8] = {0};
	
    if(charactor >= 'a' && charactor <= 'z')
    {
        keyType = 0;
        offset = charactor - 'a';
    }
    else if(charactor >= 'A' && charactor <= 'Z')
    {
        keyType = 0x02;
        offset = charactor - 'A';
    }
	else
	{
		printf("[fun:%s - Line:%d]unable to support charactor:0x%02x\n", __FUNCTION__, __LINE__, charactor);
	}

    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();

    memset(report, 0, 8);
    report[0] = keyType;
    report[2] = charBase + offset;
    write(key_fd, report, 8);
    DELAY_TIME();

    memset(report, 0, 8);
    report[0] = keyType;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();

    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();

    DELAY_WAIT_TIME(); 
    return true; 
}

static bool Hid_Send_OneGBKChinese(const unsigned char valueH, const unsigned char valueL)
{
    int i;
    unsigned char buf[16] = {0};
    unsigned char report[8] = {0};
    unsigned short value = (valueH<<8) | valueL;

    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();

    memset((unsigned char *)buf, 0, 16);
    sprintf((char *)buf, "%d", value);
    printf("value:%d  buf:%s\n", value, buf);

    for(i=0; i<16; i++)
    {
        if(buf[i] == 0) { break; }
       
        memset(report, 0, 8);
        report[0] = 0x04;
        report[2] = 0x00;
        write(key_fd, report, 8);
        DELAY_TIME();

        memset(report, 0, 8);
        report[0] = 0x04;
        report[2] = gKeyNumValue[buf[i]-'0'];
        write(key_fd, report, 8);
        DELAY_TIME();
    }
    
    //End of one gbk sending, it should send the following
    memset(report, 0, 8);
    report[0] = 0x04;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();
    
    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();

    DELAY_WAIT_TIME(); 
    return true;
}

static bool Hid_Send_Enter()
{
    unsigned char report[8] = {0};

    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x28;
    write(key_fd, report, 8);
    DELAY_TIME();

    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();

    DELAY_WAIT_TIME(); 
    return true; 
}

static bool Hid_Send_Space()
{
    unsigned char report[8] = {0};

    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x2C;
    write(key_fd, report, 8);
    DELAY_TIME();

    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();

    DELAY_WAIT_TIME(); 
    return true; 
}

/**************************
1. From ~ to ?
2. From ` to /
**************************/
static bool Hid_Send_Symbol(unsigned char symbol)
{
	unsigned char keyType;
	unsigned char keyValue;
	unsigned char report[8] = {0};

    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();

    memset(report, 0, 8);
	switch(symbol)
	{
        /*From 1 to / */
		case '1':
		    keyType = 0x00;
			keyValue = 0x1E; 
		break;
		case '2':
		    keyType = 0x00;
		    keyValue = 0x1F;
		break;
		case '3':
		    keyType = 0x00;
			keyValue = 0x20; 
		break;
		case '4':
		    keyType = 0x00;
		    keyValue = 0x21;
		break;
		case '5':
		    keyType = 0x00;
			keyValue = 0x22; 
		break;
		case '6':
		    keyType = 0x00;
		    keyValue = 0x23;
		break;
		case '7':
		    keyType = 0x00;
			keyValue = 0x24; 
		break;
		case '8':
		    keyType = 0x00;
		    keyValue = 0x25;
		break;
		case '9':
		    keyType = 0x00;
			keyValue = 0x26; 
		break;
		case '0':
		    keyType = 0x00;
		    keyValue = 0x27;
		break;
		case '-':
		    keyType = 0x00;
			keyValue = 0x2D;
		break;
		case '=':
		    keyType = 0x00;
		    keyValue = 0x2E;
		break;
		case '[':
		    keyType = 0x00;
		    keyValue = 0x2F;
		break;
		case ']':
		    keyType = 0x00;
		    keyValue = 0x30;
		break;
		case '\\':
		    keyType = 0x00;
		    keyValue = 0x31;
		break;
		case ';':
		    keyType = 0x00;
		    keyValue = 0x33;
		break;
		case '\'':
		    keyType = 0x00;
		    keyValue = 0x34;
		break;
		case '`':
		    keyType = 0x00;
		    keyValue = 0x35;
		break;
		case ',':
		    keyType = 0x00;
		    keyValue = 0x36;
		break;
		case '.':
		    keyType = 0x00;
		    keyValue = 0x37;
		break;
		case '/':
		    keyType = 0x00;
		    keyValue = 0x38;
		break;		
		/*From ! to ?*/
		case '!':
		    keyType = 0x02;
			keyValue = 0x1E; 
		break;
		case '@':
		    keyType = 0x02;
		    keyValue = 0x1F;
		break;
		case '#':
		    keyType = 0x02;
			keyValue = 0x20; 
		break;
		case '$':
		    keyType = 0x02;
		    keyValue = 0x21;
		break;
		case '%':
		    keyType = 0x02;
			keyValue = 0x22; 
		break;
		case '^':
		    keyType = 0x02;
		    keyValue = 0x23;
		break;
		case '&':
		    keyType = 0x02;
			keyValue = 0x24; 
		break;
		case '*':
		    keyType = 0x02;
		    keyValue = 0x25;
		break;
		case '(':
		    keyType = 0x02;
			keyValue = 0x26; 
		break;
		case ')':
		    keyType = 0x02;
		    keyValue = 0x27;
		break;
		case '_':
		    keyType = 0x02;
			keyValue = 0x2D;
		break;
		case '+':
		    keyType = 0x02;
		    keyValue = 0x2E;
		break;
		case '{':
		    keyType = 0x02;
		    keyValue = 0x2F;
		break;
		case '}':
		    keyType = 0x02;
		    keyValue = 0x30;
		break;
		case '|':
		    keyType = 0x02;
		    keyValue = 0x31;
		break;
		case ':':
		    keyType = 0x02;
		    keyValue = 0x33;
		break;
		case '"':
		    keyType = 0x02;
		    keyValue = 0x34;
		break;
		case '~':
		    keyType = 0x02;
		    keyValue = 0x35;
		break;
		case '<':
		    keyType = 0x02;
		    keyValue = 0x36;
		break;
		case '>':
		    keyType = 0x02;
		    keyValue = 0x37;
		break;
		case '?':
		    keyType = 0x02;
		    keyValue = 0x38;
		break;
		
		default:
		    printf("[fun:%s - Line:%d]unable to support symbol:0x%x\n", __FUNCTION__, __LINE__, symbol);
		return false;
	}
	
    memset(report, 0, 8);
    report[0] = keyType;
    report[2] = keyValue;
    write(key_fd, report, 8);
    DELAY_TIME();

    memset(report, 0, 8);
    report[0] = keyType;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();
	
    memset(report, 0, 8);
    report[0] = 0x00;
    report[2] = 0x00;
    write(key_fd, report, 8);
    DELAY_TIME();

    DELAY_WAIT_TIME(); 
    return true;
}

static bool Hidg_Send_Test()
{
	unsigned char charactor;
	
    sleep(5);
	
    Hid_Send_OneGBKChinese(0xBB, 0xE1);
	Hid_Send_OneGBKChinese(0xB5, 0xB1);
    Hid_Send_Space();
    Hid_Send_Enter();

	
	charactor = 'a';
	while(charactor <= 'z')
	{
		Hid_Send_OneGBKEnglish(charactor++);
		Hid_Send_Space();
	}
	Hid_Send_Enter();
	charactor = 'A';
	while(charactor <= 'Z')
	{
		Hid_Send_OneGBKEnglish(charactor++);
		Hid_Send_Space();
	}
	Hid_Send_Enter();
	
	
    Hid_Send_Symbol('`');
    Hid_Send_Space();
    Hid_Send_Symbol('1');
    Hid_Send_Space();
    Hid_Send_Symbol('2');
    Hid_Send_Space();
    Hid_Send_Symbol('3');
    Hid_Send_Space();
    Hid_Send_Symbol('4');
    Hid_Send_Space();
    Hid_Send_Symbol('5');
    Hid_Send_Space();
    Hid_Send_Symbol('6');
    Hid_Send_Space();
    Hid_Send_Symbol('7');
    Hid_Send_Space();
    Hid_Send_Symbol('8');
    Hid_Send_Space();
    Hid_Send_Symbol('9');
    Hid_Send_Space();
    Hid_Send_Symbol('0');
    Hid_Send_Space();
    Hid_Send_Symbol('-');
    Hid_Send_Space();
    Hid_Send_Symbol('=');
    Hid_Send_Space();
    Hid_Send_Symbol('[');
    Hid_Send_Space();
    Hid_Send_Symbol(']');
    Hid_Send_Space();
    Hid_Send_Symbol(';');
    Hid_Send_Space();
    Hid_Send_Symbol('\'');
    Hid_Send_Space();
    Hid_Send_Symbol('\\');
    Hid_Send_Space();
    Hid_Send_Symbol(',');
    Hid_Send_Space();
    Hid_Send_Symbol('.');
    Hid_Send_Space();
    Hid_Send_Symbol('/');
    Hid_Send_Space();
	Hid_Send_Enter();
	
    Hid_Send_Symbol('~');
    Hid_Send_Space();
    Hid_Send_Symbol('!');
    Hid_Send_Space();
    Hid_Send_Symbol('@');
    Hid_Send_Space();
    Hid_Send_Symbol('#');
    Hid_Send_Space();
    Hid_Send_Symbol('$');
    Hid_Send_Space();
    Hid_Send_Symbol('%');
    Hid_Send_Space();
    Hid_Send_Symbol('^');
    Hid_Send_Space();
    Hid_Send_Symbol('&');
    Hid_Send_Space();
    Hid_Send_Symbol('*');
    Hid_Send_Space();	
    Hid_Send_Symbol('(');
    Hid_Send_Space();
    Hid_Send_Symbol(')');
    Hid_Send_Space();
    Hid_Send_Symbol('_');
    Hid_Send_Space();
    Hid_Send_Symbol('+');
    Hid_Send_Space();
    Hid_Send_Symbol('{');
    Hid_Send_Space();
    Hid_Send_Symbol('}');
    Hid_Send_Space();
    Hid_Send_Symbol(':');
    Hid_Send_Space();
    Hid_Send_Symbol('"');
    Hid_Send_Space();
    Hid_Send_Symbol('|');
    Hid_Send_Space();	
    Hid_Send_Symbol('<');
    Hid_Send_Space();
    Hid_Send_Symbol('>');
    Hid_Send_Space();
    Hid_Send_Symbol('?');
    Hid_Send_Space();
    Hid_Send_Enter();

    return true;

}

static bool Hidg_Dev_Init(char *key_path, char *mouse_path)
{ 
    key_fd = open(key_path, O_RDWR, 0666);
    if(key_fd < 0)
    {
        return false;
    }


    return true;
}

static void Hidg_Dev_DeInit(void)
{ 
    close(key_fd);
}


int main(int argc, char **argv)
{
    if(!Hidg_Dev_Init((char *)Key_DevName, (char *)Key_DevName))
    {
        printf("Hidg_Dev_Init err\n");
        return -1;
    }

	Hidg_Send_Test();

    return 0;
}
